require 'capistrano/distribution/distributor/abstract_archiver'
require 'capistrano/distribution/distributor/tar_helper'

module Capistrano
class Distribution
module Distributor

##
# Deploys locally available Tar files.
class Tar < AbstractArchiver
  include TarHelper

  ##
  # Extracts the content rooted under {#subtree} within the Tar file indicated
  # by {#url} to the location indicated by {#release_path}.
  #
  # @return [nil]
  #
  # @see Abstract#distribute
  def distribute
    context.execute 'mkdir', '-p', release_path
    context.execute 'tar', '-x',
                    compression_opt,
                    strip_components_opt,
                    '-C', release_path,
                    '-f', url.path,
                    subtree

    nil
  end
end

end
end
end
