require 'capistrano/distribution/distributor/abstract_archiver'

module Capistrano
class Distribution
module Distributor

##
# Deploys locally available ZIP files.
class Zip < AbstractArchiver
  ##
  # Extracts the content rooted under {#subtree} within the ZIP file indicated
  # by {#url} to the location indicated by {#release_path}.
  #
  # @return [nil]
  #
  # @see Abstract#distribute
  def distribute
    context.execute 'mkdir', '-p', repo_path
    context.execute 'unzip', '-q',
                    '-d', repo_path,
                    url.path,
                    subtree.join('\\*')
    context.execute 'mv', repo_path.join(subtree), release_path

    nil
  end
end

end
end
end
